"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GrpcService = void 0;
/* eslint-disable */
const grpc_web_1 = require("grpc-web");
const test_pb_1 = require("./codegen/test_pb");
class GrpcService {
    constructor(hostname) {
        this.metadata = {};
        this.interceptors = {
            errors: []
        };
        this.makeInterceptedUnaryCall = (command, params, methodInfo) => {
            const unaryCallHandler = () => this.client.unaryCall(command, params, this.metadata, methodInfo);
            if (this.interceptingPromise) {
                return this.interceptingPromise.then(() => {
                    this.interceptingPromise = undefined;
                    return unaryCallHandler();
                });
            }
            return new Promise((resolve, reject) => {
                unaryCallHandler().catch(e => {
                    this.chainingInterceptors(this.interceptors.errors, e).then(() => {
                        this.makeInterceptedUnaryCall(command, params, methodInfo).then(resolve).catch(reject);
                    });
                });
            });
        };
        this.chainingInterceptors = (interceptors, value) => {
            this.interceptingPromise = interceptors.reduce((chain, nextInterceptor) => chain.then(nextInterceptor), Promise.resolve(value));
            return this.interceptingPromise;
        };
        this.setMetadata = (metadata = {}) => {
            this.metadata = Object.assign({}, this.metadata, metadata);
        };
        this.TestService = {
            RefreshToken: (params) => {
                const methodInfo = new grpc_web_1.AbstractClientBase.MethodInfo(test_pb_1.Test.EmptyMessage, (request) => test_pb_1.Test.EmptyMessage.encode(request).finish(), test_pb_1.Test.EmptyMessage.decode);
                return this.makeInterceptedUnaryCall(this.hostname + '/Test.TestService/RefreshToken', params, methodInfo);
            },
            GetOrder: (params) => {
                const methodInfo = new grpc_web_1.AbstractClientBase.MethodInfo(test_pb_1.Test.EmptyMessage, (request) => test_pb_1.Test.EmptyMessage.encode(request).finish(), test_pb_1.Test.EmptyMessage.decode);
                return this.makeInterceptedUnaryCall(this.hostname + '/Test.TestService/GetOrder', params, methodInfo);
            },
        };
        this.client = new grpc_web_1.GrpcWebClientBase({});
        this.hostname = hostname;
    }
}
exports.GrpcService = GrpcService;
;
